module.exports = {
    friendlyName: "Find",

    description: "Find Eleves Parents.",

    inputs: {
        search: {
            type: "string",
        },
        

    },

    exits: {
        notFound: {
            statusCode: 404
        },
    },

    fn: async function (inputs, exits) {
        const { id, user } = this.req.token;
        //console.log("ID", id, user.login, user.typeUser, user.codeEcole, user.nom)
        //console.log("ID", id, inputs.codeClasse, inputs.anneeScolaire, inputs.trimSem)

        // VERIFICATION DU CODE ECOLE
        if (user.codeEcole === '' || user.codeEcole === null || user.codeEcole === undefined) {
            return exits.notFound({ message: "Veuillez préciser le code Ecole pour cet utulisateur pour a accéder a cette page!" })
        }
        let ecoleVerif = await Ecoles.find({ codeEcole: user.codeEcole }).then(_.first)
        if (!ecoleVerif) {
            return exits.notFound({ message: "Cet utilisateur n'est attribué a aucune classe!" })
        }
        // FIN VERIF CODE ECOLE

        // VERIF SI ANNEE SCOLAIRE EST PASSEE
        // console.log("Annee Scolaire", inputs.anneeScolaire)

        let userCodeEcole;
        if (user.typeUser === 'PARENT') {
            userCodeEcole = user.codeEcole
        } else {
            return exits.notFound({ message: "Vous n'etes pas autoriser a accéder a cette page!" })

        }
        //console.log("userCodeEcole", userCodeEcole)

        //JE CHERCHE LE CODE PARENT DE L'UTILISATEUR QUI EST CONNECTER
        let parent = await Parents.find({ codeParent: user.codeUser,/* nom: user.nom,*/ codeEcole: userCodeEcole, }).then(_.first);
        if (!parent) {
            return exits.notFound({ message: "Vous n'etes pas autoriser a accéder a cette page!" })
        }
        // JE CHERCHER LES ELEVES LIES A CE PARENT
        let filiations = await Filiation.find({ codeParent: parent.codeParent, codeEcole: userCodeEcole, })
            .then(filiations => {
                return Promise.all(filiations.map(async filiation => {
                    //console.log('matieres', matieres)

                    //JE VAIS CHERCHER LE NOM DE L'ELEVE
                    if (filiation.matricule) {
                        let eleve = await Eleves.find({ matricule: filiation.matricule, }).then(_.first);
                        filiation.eleve = eleve
                        filiation.nom = eleve.nom
                    }

                    filiation.ecole = ecoleVerif

                    return filiation
                })
                );

            })

        // All done.
        return exits.success(filiations);
    },
};
